import java.awt.*;
public class OvalNode implements ShapeNode{
    private Color c;
    private ShapeNode next;
    private int element;
    private int x;
    private int y;
    private int w;
    private int h;
    public OvalNode(Color color, int inElement, int xPos, int yPos, int width, int height){
        element = inElement;
        x = xPos;
        y = yPos;
        w = width;
        h = height;
        c = color;
        next = null;
    }
    public void setWidth(int w){
        this.w = w;
    }
    public void translate(int xplus, int yplus){
        x+=xplus;
        y+=yplus;
    }
    public void setPos(int xn, int yn){
        x = xn-w/2;
        y = yn-h/2;
    }
    public void drawShape(Graphics g){
        g.setColor(c);
        g.fillOval(x,y,w,h);
    }
    public void setColor(Color color){
        c = color;
    }
    public Color getColor(){
        return c;
    }
    public void setNext(ShapeNode s){
        next = s;
    }
    public ShapeNode getNext(){
        return next;
    }
    public boolean hasNext(){
        if(next==null){
            return false;
        }
        else{
            return true;
        }
    }
    public boolean hasNextProper(){
        if(!hasNext()){
            return false;
        }
        else{
            if(next.isBookmark()){
                return false;
            }
            else{
                return true;
            }
        }
    }
    public void removeNext(){
        setNext(next.getNext());
    }
    public ShapeNode last(){
        if(next==null){
            return this;
        }
        if(next.isBookmark()){
            return this;
        }
        else{
            return next.last();
        }
    }
    public boolean isBookmark(){
        return false;
    }
    public boolean doesIdentify(int checkElement){
        if(checkElement==element){
            return true;
        }
        else{
            return false;
        }
    }
    public int getElement(){
        return element;
    }
}