
public class Vector {
	private double i;
	private double j;
	private double k;
	
	public Vector(double x, double y, double z){
		i = x;
		j = y;
		k = z;
	}
	
	public double mag(){
		return Math.sqrt(i*i+j*j+k*k);
	}
	public double x(){
		return i;
	}
	public double y(){
		return j;
	}
	public double z(){
		return k;
	}
	public void add(Vector v){
		add(v.x(),v.y(),v.z());
	}
	public void add(double x, double y, double z){
		i += x;
		j += y;
		k += z;
	}
	
	public static Vector diff(Vector a,Vector b){
		return new Vector(a.x()-b.x(),a.y()-b.y(),a.z()-b.z());
	}
	public static Vector sum(Vector a,Vector b){
		return new Vector(a.x()+b.x(),a.y()+b.y(),a.z()+b.z());
	}
	public static double dot(Vector a,Vector b){
		return (a.x()*b.x())+(a.y()*b.y())+(a.z()*b.z());
	}
	public static Vector cross(Vector a,Vector b){
		return new Vector(a.y()*b.z()-a.z()*b.y(),a.z()*b.x()-a.x()*b.z(),a.x()*b.y()-a.y()*b.x());
	}
	public static Vector scale(Vector a,double k){
		return new Vector(a.x()*k,a.y()*k,a.z()*k);
	}
}
